/*  ==========================
 *  Semestrln prce z Y36SPS
 *  SNMP Interfaces enumerator
 *  Petr Kouteck
 *  ==========================
 * 
 *  Program je napsn v C# ve Visual Studiu 2005 pro platformu Windows, ke sv innosti potebuje NET Framework 2.0 nebo novj. Pi sputn bez parametr vype npovdu k uit parametr: 
      SNMP3.exe file [-o output] [-c cs] [-t timeout]
              file - soubor se seznam host ve form IP adres, na kadm dku 1 adresa
              output - soubor vstupu, formt PNG, vchoz output.PNG
              cs - comunity string, vchoz=public
              timeout - timeout spojen v ms, vchoz=2000
 * 
 * Dal roziovn programu je mon pedevm v mnostv zjiovn informac (viz. MIB databze). 
 * Dle by bylo mon rozit a vylepit algoritmus pro kreslen obrzku - souasn verze neum sprvn vykreslit 
 * router zapojen do vce ne 2 st.
 * 
 * Pouit zdroje:
 * MIBBrowser database viewer
 * http://www.ks-soft.net
 * 
 * Simple SNMP
 * http://www.java2s.com/Code/CSharp/Network/SimpleSNMP.htm
 */



using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace SNMP3
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WindowWidth = Console.LargestWindowWidth - 6; //sirka okna konzole

            if (args.Length > 1 && args.Length < 8)
            {
                Console.WriteLine("=====================================================");
                Console.WriteLine("=                                                   =");
                Console.WriteLine("=            SNMP Interfaces Enumerator             =");
                Console.WriteLine("=                                                   =");
                Console.WriteLine("=====================================================");
                Console.WriteLine();

                if (!File.Exists(args[0]))
                //soubor se seznamem hostu neexistuje
                {
                    Console.WriteLine("Soubor " + args[0] + " neexistuje!");
                    return;
                }

                int timeout = 2000;// default timeout
                string cs = "public"; //default comunity string
                string vystup = "output.png";

                for (int i = 1; i < args.Length; i++)
                {
                    if (args[i] == "-c")
                        cs = args[i + 1];
                    else if (args[i] == "-o")
                        vystup = args[i + 1];
                    else if (args[i] == "-t")
                        timeout = int.Parse(args[i + 1]);
                }

                //projdu vsechny hosty
                SNMPInfo.enumInterfaces(args[0], cs, timeout,vystup);
            }
            else
                //vypu nvod k pouit
                Console.WriteLine("Pouit:\n\tSNMP3.exe file [-o output] [-c cs] [-t timeout]\n\n\t\tfile - soubor se seznam host ve form IP adres, na kadm dku 1 adresa\n\t\t-o output - soubor vstupu\n\t\tcs - comunity string, vchoz=public\n\t\ttimeout - timeout spojen v ms, vchoz=2000");

            //ukonen stiskem libovoln klvesy
            Console.ReadKey();
        }
    }
}
